include \masm32\MasmBasic\MasmBasic.inc	; [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
FillArray	PROTO: SDWORD
qsc_proRealComisd	PROTO
qsc_proRealFcomip	PROTO

.data
Times8n	REAL8 12.2, 11.1, -13.4, -12.3, -15.5, 16.7, 20.0, 15.6, 19.9, 17.8
RealRangeLo	REAL8 -2222.2222
RealRangeHi	REAL8 2222.2222
DwRange=	1000000
QwRange=	123456789
TestDesc=	0	; put 1 to test also the descending order

ShowOrder MACRO arg	; little macro for showing the sorted arrays
LOCAL a1, a2, a3
  a1=arg eq TiDw()
  a2=arg eq TiR8()
  a3=arg eq MyR8()
  if NumShow
	For_ ebx=0 To MaxIndex
		.if ebx<NumShow || ebx>MaxIndex-NumShow
			if a1
				Print Str$(ebx), Str$("\t%i\n", TiDw(ebx))
			elseif a2
				Print Str$(ebx), Str$("\t%f\n", TiR8(ebx))
			else
				Print Str$(ebx), Str$("\t%f\n", MyR8(ebx))
			endif
		.endif
	Next
  endif
ENDM
	Init
	MaxIndex=5000000
	Dim TiDw(MaxIndex) As DWORD
	Dim TiQw(MaxIndex) As QWORD
	Dim TiR4(MaxIndex) As REAL4
	Dim TiR8(MaxIndex) As REAL8
	Dim MyR8(9) As REAL8
if 0
	Bmove offset Times8n, VarPtr(MyR8(0)), 80

	; ArraySort MyR8()
;	int 3
	invoke crt_qsort, addr MyR8(0), 10, REAL8, qsc_proRealComisd
;	MsgBox 0, "OK", "Hi", MB_OK
	NumShow = 99	; put e.g. 3 to see the first and last 5 sorted values, or 0 for no show
	MaxIndex=9
	ShowOrder MyR8()
	Exit debug	; OxPT_Wait 1
else
	PrintCpu
	Print Str$("Sorting %i items:\n", MaxIndex)
	REPEAT 2
		NumShow = 0	; put e.g. 3 to see the first and last 5 sorted values, or 0 for no show
		invoke FillArray, 1	; 1=load random numbers into DWORD array
		NanoTimer()
		ArraySort TiDw()
		Print Str$("%i ms for ArraySort+, Dword\n", NanoTimer(ms))
		ShowOrder TiDw()
		if TestDesc
			invoke FillArray, 1
			NanoTimer()
			ArraySort TiDw(-)
			Print Str$("%i ms for ArraySort-\n", NanoTimer(ms))
			Print
		endif
		invoke FillArray, 1
		NanoTimer()
		invoke nrQsortA, addr TiDw(0), MaxIndex+1
		Print Str$("%i ms for nrQsortA, Dword\n", NanoTimer(ms))
		ShowOrder TiDw()
		if TestDesc
			invoke FillArray, 1
			NanoTimer()
			invoke nrQsortD, addr TiDw(0), MaxIndex+1
			Print Str$("%i ms for nrQsortD\n", NanoTimer(ms))
		endif
		Print
	ENDM

	REPEAT 1
		invoke FillArray, 3	; 1=load random numbers into REAL8 array
		NanoTimer()
		ArraySort TiR8()
		Print Str$("\n%i ms for ArraySort+, Real8\n", NanoTimer(ms))
		NumShow=2
		ShowOrder TiR8()
		if TestDesc
			invoke FillArray, 3
			NanoTimer()
			ArraySort TiR8(-)
			Print Str$("%i ms for ArraySort-\n", NanoTimer(ms))
			ShowOrder TiR8()
		endif

		invoke FillArray, 3	; 1=load random numbers into REAL8 array
		NanoTimer()
		invoke crt_qsort, addr TiR8(0), MaxIndex+1, REAL8, qsc_proRealComisd
		Print Str$("\n%i ms for CRT qsort Comisd, Real8\n", NanoTimer(ms))
		ShowOrder TiR8()

		invoke FillArray, 3	; 1=load random numbers into REAL8 array
		NanoTimer()
		invoke crt_qsort, addr TiR8(0), MaxIndex+1, REAL8, qsc_proRealFcomip
		Print Str$("\n%i ms for CRT qsort Fcomip, Real8\n", NanoTimer(ms))
		ShowOrder TiR8()

		NumShow=0
		Print
	ENDM
	Inkey "ok"
	Exit
endif
.code
FillArray proc uses ebx mode:SDWORD
  .if mode==1 || mode<0
	mov ebx, TiDw(?)
	.Repeat
		mov TiDw(ebx), Rand(DwRange)
		dec ebx
	.Until Sign?
	; PrintLine "DW filled"
  .endif
  .if mode==2 || mode<0
	mov ebx, TiR4(?)
	.Repeat
		Rand(RealRangeLo, RealRangeHi, TiR4(ebx))	; put random number into Real8 array
		dec ebx
	.Until Sign?
	; PrintLine "R4 filled"
  .endif
  .if mode==3 || mode<0
	mov ebx, TiR8(?)
	.Repeat
		Rand(RealRangeLo, RealRangeHi, TiR8(ebx))	; put random number into Real8 array
		dec ebx
	.Until Sign?
	; PrintLine "R8 filled"
  .endif
  .if mode==3 || mode<0
	mov ebx, TiQw(?)
	.Repeat
			Rand(0, QwRange, TiQw(ebx))
		dec ebx
	.Until Sign?
	; PrintLine "Qw filled"
  .endif
  ret
FillArray endp

qsc_proRealFcomip proc	; C arg1:DWORD,arg2:DWORD
	mov eax, [esp+4]	; arg1
	mov edx, [esp+8]	; arg2
	ffree st(7)	; should be done once, elsewhere
	ffree st(7)	; although it seems not to slow down the algo
	fldz
	fld REAL8 PTR [eax]
	fsub REAL8 PTR [edx]
	xor eax, eax
	fcomip ST, ST(1)	; works!
	je @F
	.if Carry?
		dec eax
	.else
		inc eax
	.endif
	@@:
	fstp st
	retn
qsc_proRealFcomip endp

qsc_proRealComisd proc	; C arg1:DWORD,arg2:DWORD
	mov eax, [esp+4]	; arg1
	mov edx, [esp+8]	; arg2
	movlps xmm0, REAL8 PTR [eax]
	xor eax, eax
	comisd xmm0,  REAL8 PTR [edx]	; sets carry
	je @F
	.if Carry?
		dec eax
	.else
		inc eax
	.endif
	@@:
	retn
qsc_proRealComisd endp

end start

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
; DwRange=200000
158 ms for ArraySort+, Dword
164 ms for nrQsortA, Dword

159 ms for ArraySort+, Dword
163 ms for nrQsortA, Dword

157 ms for ArraySort+, Dword
163 ms for nrQsortA, Dword

280 ms for ArraySort+, Real8
570 ms for CRT qsort,  Real8

AMD Athlon(tm) Dual Core Processor 4450B (SSE3)
; DwRange=200000
111 ms for ArraySort+, Dword
144 ms for nrQsortA, Dword

110 ms for ArraySort+, Dword
146 ms for nrQsortA, Dword

113 ms for ArraySort+, Dword
146 ms for nrQsortA, Dword

215 ms for ArraySort+, Real8
447 ms for CRT qsort,  Real8

OPT_Assembler	mlv615
OPT_Errline	0
OPT_Tmp2Asm	1
